% function GUI(musArr44, clickArr, clickArr12, cntArr44, corStrArr12, corStrArr, sinClickArr44)

figure(1);

GUI.curveCentDist = 1.2;
GUI.curveDistOff = GUI.curveCentDist/2; % Toppen av vinduet

GUI.maxClickNr = size(A.corArrDB, 1);
GUI.minClickNr = 1;

GUI.modi = 'std';
GUI.selectRange = [0 0];
GUI.b = 0;

while  GUI.b ~= 113 % q
    
    [GUI.x, GUI.y, GUI.b] = ginput2(1);
    pause(0.1);
    
    GUI.clickBredde = P.endClickNr - P.startClickNr;
    
    %%
    if GUI.b == double('c') % kopier mov til ch2
        mov(:,3) = mov(:,2);
        
        % reload
        A.corArrDB = readcell([P.workDir 'cor.xls']); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
        A.corArrDB(cellfun(@(x) any(ismissing(x)), A.corArrDB)) = {''}; % fix
        A.clickDBtimeMs = cell2mat(A.corArrDB(:,1)); % ms, tider for DownBeat
        A.corValArrB = makeCorValArrB(A.corArrDB, P.workDir); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
        A.clickBtimeMs = A.corValArrB(:,1); % ms, tider for Beat
        A.cntArr525 = makeCntArr525(A.corValArrB);
        
        plotCurves(A, P);
    end    
    if GUI.b == 28 % pil V
        P.startClickNr = P.startClickNr - GUI.clickBredde + 1;
        P.endClickNr = P.endClickNr - GUI.clickBredde + 1;
        
        P.startClickNr = min(max(P.startClickNr, 1), GUI.maxClickNr);
        P.endClickNr = P.startClickNr + GUI.clickBredde;
        
        plotCurves(A, P);
    end
    if GUI.b == 124 % <
        P.startClickNr = P.startClickNr - floor(GUI.clickBredde/2) + 1;
        P.endClickNr = P.endClickNr - floor(GUI.clickBredde/2) + 1;
        
        P.startClickNr = min(max(P.startClickNr, 1), GUI.maxClickNr);
        P.endClickNr = P.startClickNr + GUI.clickBredde;
        
        plotCurves(A, P);
    end
    if GUI.b == 29 % pil H
        P.endClickNr = P.endClickNr + GUI.clickBredde + 1;
        
        P.endClickNr = min(max(P.endClickNr, 1), GUI.maxClickNr);
        P.startClickNr = P.endClickNr - GUI.clickBredde;
        
        plotCurves(A, P);
    end
    if GUI.b == 65447 % >
        P.endClickNr = P.endClickNr + floor(GUI.clickBredde/2) - 1;
        
        P.endClickNr = min(max(P.endClickNr, 1), GUI.maxClickNr);
        P.startClickNr = P.endClickNr - GUI.clickBredde;
        
        plotCurves(A, P);
    end
    
    if GUI.b == 31 % pil ned zoom in
        GUI.clickBredde = max(floor(GUI.clickBredde/2), 2);
        P.endClickNr = P.startClickNr + GUI.clickBredde;
        
        plotCurves(A, P);
    end
    if GUI.b == 30 % pil opp zoom out
        GUI.clickBredde = floor(2*GUI.clickBredde);
        P.endClickNr = P.startClickNr + GUI.clickBredde;
        
        P.endClickNr = min(max(P.endClickNr, 1), GUI.maxClickNr);
        
        plotCurves(A, P);
    end
    
    if GUI.b == double('A') % A - plot  all
        GUI.oldEndClickNr = P.endClickNr;
        GUI.oldStartClickNr = P.startClickNr;
        GUI.oldClickBredde = GUI.clickBredde;
        
        P.endClickNr = GUI.maxClickNr;
        P.startClickNr = 1;
        GUI.clickBredde = P.endClickNr - P.startClickNr;
        
        plotCurves(A, P);
    end
    
    if GUI.b == double('a') % a - plot gammel før all
        P.endClickNr = GUI.oldEndClickNr;
        P.startClickNr = GUI.oldStartClickNr;
        GUI.clickBredde = P.endClickNr - P.startClickNr;
        
        plotCurves(A, P);
    end
    
    if GUI.b == double('p') % p: play section in wind
        runMusic(A, P, 1);
    end
    
    if GUI.b == double('P') % p: play section in wind
        runMusic(A, P, 0.5);
    end    
    
    if GUI.b == double('x') % x run preview vindu med mover uten lerret med lyd
        %runPreview1(A.wavClick44100,  A.clickDBtimeMs, A.cntArr525, P.startClickNr, P.endClickNr, 1);
        runPreviewEtyp1(A,P,1);
    end
    
    if GUI.b == double('X') % x run preview vindu med mover uten lerret med lyd
        %runPreview1(A.wavClick44100,  A.clickDBtimeMs, A.cntArr525, P.startClickNr, P.endClickNr, 2);
        runPreviewEtyp1(A,P,2);
    end    
    
    if GUI.b == double('r') % r reload cor
        A.corArrDB = readcell([P.workDir 'cor.xls']); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
        A.corArrDB(cellfun(@(x) any(ismissing(x)), A.corArrDB)) = {''}; % fix
        A.clickDBtimeMs = cell2mat(A.corArrDB(:,1)); % ms, tider for DownBeat
        A.corValArrB = makeCorValArrB(A.corArrDB, P.workDir, P.noBeatsPerBar); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
        A.clickBtimeMs = A.corValArrB(:, 1, 1); % ms, tider for Beat
        A.cntArr525 = makeCntArr525(A.corValArrB);
        
        plotCurves(A, P);
    end
    
    % Klikk i Curve 1
    GUI.y0 = -1.87; GUI.y05 = -1.495; GUI.yMin = GUI.y0-(GUI.y05-GUI.y0)*2; GUI.yMax = GUI.y0+(GUI.y05-GUI.y0)*2; % Hentet med datatips
    if GUI.y > GUI.yMin-0.1 && GUI.y < GUI.yMax+0.1 
        if GUI.b == 1 % legger inn ny mov verdi
            GUI.yy = moveLinRange(GUI.y, 1, -1, GUI.yMax, GUI.yMin); % (x, maxOutVal, minOutVal, maxInVal, minInVal)
            GUI.yy = quanti(GUI.yy);
            [GUI.dBno] = findNermesteDBnedover(GUI.x, A.clickDBtimeMs);
            [GUI.movName, GUI.moveStartDBno] = findMoveFromDBno(A.corArrDB, GUI.dBno);
            GUI.i = findBindexInMovFromSampNo(A.corValArrB, GUI.moveStartDBno, GUI.x, P.noBeatsPerBar);

            mov = loadMovFromFile(P.workDir, GUI.movName, P.noBeatsPerBar); % load([P.workDir GUI.movName '.txt']);
            if mov(GUI.i, 2, 1) == GUI.yy
                mov(GUI.i, 2, 1) = NaN;
                mov = fillInSkewsToNextVals(mov);
            else
                mov(GUI.i, 2, 1) = GUI.yy;
            end
            if mov(GUI.i, 2, 1) == 1 || mov(GUI.i, 2, 1) == -1
               mov(GUI.i, 2, 2) = 1; % flipper
            else
               mov(GUI.i, 2, 2) = 0; 
            end
            mov(:, 3, 1) = mov(:, 2, 1);
            saveMovToFile(mov, [P.workDir GUI.movName '.txt']);
        end
        if GUI.b == 2 % flipper ang
            [GUI.dBno] = findNermesteDBnedover(GUI.x, A.clickDBtimeMs);
            [GUI.movName, GUI.moveStartDBno] = findMoveFromDBno(A.corArrDB, GUI.dBno);
            GUI.i = findBindexInMovFromSampNo(A.corValArrB, GUI.moveStartDBno, GUI.x, P.noBeatsPerBar);

            mov = loadMovFromFile(P.workDir, GUI.movName, P.noBeatsPerBar); % load([P.workDir GUI.movName '.txt']);
            if isnan(mov(GUI.i, 2, 1)) == 0
                mov(GUI.i, 2, 2) = ~mov(GUI.i, 2, 2);
                mov(:, 3, 2) = mov(:, 2, 2);
                saveMovToFile(mov, [P.workDir GUI.movName '.txt']);  
            end
        end
        if GUI.b == 3 % setter skew
            GUI.yy = moveLinRange(GUI.y, 1, -1, GUI.yMax, GUI.yMin); % (x, maxOutVal, minOutVal, maxInVal, minInVal)
            GUI.yy = 4*quanti(GUI.yy);   % -3 ... 3   
            GUI.yy = min(3, max(-3,GUI.yy));
            [GUI.dBno] = findNermesteDBnedover(GUI.x, A.clickDBtimeMs);
            [GUI.movName, GUI.moveStartDBno] = findMoveFromDBno(A.corArrDB, GUI.dBno);
            GUI.i = findBindexInMovFromSampNo(A.corValArrB, GUI.moveStartDBno, GUI.x, P.noBeatsPerBar);

            mov = loadMovFromFile(P.workDir, GUI.movName, P.noBeatsPerBar); % load([P.workDir GUI.movName '.txt']);
            if isnan(mov(GUI.i, 2, 1)) == 0
                mov(GUI.i, 2, 3) = GUI.yy;
                mov = fillInSkewsToNextVals(mov);
                saveMovToFile(mov, [P.workDir GUI.movName '.txt']);  
            end
        end        
        
        % reload
        A.corArrDB = readcell([P.workDir 'cor.xls']); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
        A.corArrDB(cellfun(@(x) any(ismissing(x)), A.corArrDB)) = {''}; % fix
        A.clickDBtimeMs = cell2mat(A.corArrDB(:,1)); % ms, tider for DownBeat
        A.corValArrB = makeCorValArrB(A.corArrDB, P.workDir, P.noBeatsPerBar); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
        A.clickBtimeMs = A.corValArrB(:, 1, 1); % ms, tider for Beat
        A.cntArr525 = makeCntArr525(A.corValArrB);
        
        plotCurves(A, P);
    end
 
%     % Klikk i Curve 2
%     GUI.y0 = -3.52; GUI.y05 = -3.145; GUI.yMin = GUI.y0-(GUI.y05-GUI.y0)*2; GUI.yMax = GUI.y0+(GUI.y05-GUI.y0)*2; % Hentet med datatips
%     if GUI.y > GUI.yMin-0.1 && GUI.y < GUI.yMax+0.1 && GUI.b==1 
%         GUI.yy = moveLinRange(GUI.y, 1, -1, GUI.yMax, GUI.yMin); % (x, maxOutVal, minOutVal, maxInVal, minInVal)
%         GUI.yy = quanti(GUI.yy);
%         [GUI.dBno] = findNermesteDBnedover(GUI.x, A.clickDBtimeMs);
%         [GUI.movName, GUI.moveStartDBno] = findMoveFromDBno(A.corArrDB, GUI.dBno);
%         GUI.i = findBindexInMovFromSampNo(A.corValArrB, GUI.moveStartDBno, GUI.x);
%         mov = loadMovFromFile(P.workDir, GUI.movName);
%         if mov(GUI.i, 3, 1) == GUI.yy
%             mov(GUI.i, 3, 1) = NaN;
%         else
%             mov(GUI.i, 3, 1) = GUI.yy;
%         end
%         saveMovToFile(mov, [P.workDir GUI.movName '.txt']);
%         
%         % reload
%         A.corArrDB = readcell([P.workDir 'cor.xls']); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
%         A.corArrDB(cellfun(@(x) any(ismissing(x)), A.corArrDB)) = {''}; % fix
%         A.clickDBtimeMs = cell2mat(A.corArrDB(:,1)); % ms, tider for DownBeat
%         A.corValArrB = makeCorValArrB(A.corArrDB, P.workDir); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
%         A.clickBtimeMs = A.corValArrB(:, 1, 2); % ms, tider for Beat
%         A.cntArr525 = makeCntArr525(A.corValArrB);
%         
%         plotCurves(A, P);
%     end  

    % Klikk i mov navn
    if GUI.y < -4.3625 && GUI.y > -4.6139 
        [GUI.dBno] = findNermesteDBnedover(GUI.x, A.clickDBtimeMs);
        if GUI.b == 3 % bytter mov navn for alle instanser
            [GUI.movName, GUI.moveStartDBno] = findMoveFromDBno(A.corArrDB, GUI.dBno);
            GUI.nyttMname = guiTxtIn('Oppgi mov navn for å bytte alle mov instanser - return');
            A.corArrDB = swapMov([P.workDir 'cor.xls'], GUI.movName, GUI.nyttMname);
        end
        if GUI.b == 1 % Setter inn bare her
            GUI.nyttMname = guiTxtIn('Oppgi mov navn for å bytte mov bare her - return');
            makeNewEmptyMovIfNotExist(GUI.nyttMname, P.workDir); % Hvis ikke fins på fil lages det nå 
            A.corArrDB = insertMovName([P.workDir 'cor.xls'], GUI.dBno, GUI.nyttMname);
        end
        
        % reload
        A.corArrDB = readcell([P.workDir 'cor.xls']); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
        A.corArrDB(cellfun(@(x) any(ismissing(x)), A.corArrDB)) = {''}; % fix
        A.clickDBtimeMs = cell2mat(A.corArrDB(:,1)); % ms, tider for DownBeat
        A.corValArrB = makeCorValArrB(A.corArrDB, P.workDir, P.noBeatsPerBar); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
        A.clickBtimeMs = A.corValArrB(:,1); % ms, tider for Beat
        A.cntArr525 = makeCntArr525(A.corValArrB);
        
        plotCurves(A, P);
    end
    
    % Klikk i event
    if GUI.y < -4.6139 && GUI.y > -4.7790 
        [GUI.dBno] = findNermesteDBnedover(GUI.x, A.clickDBtimeMs);

        nyttEvent = guiTxtIn('Oppgi event navn - return');
        A.corArrDB = insertEventName([P.workDir 'cor.xls'], GUI.dBno, nyttEvent);
        
        % reload
        A.corArrDB = readcell([P.workDir 'cor.xls']); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
        A.corArrDB(cellfun(@(x) any(ismissing(x)), A.corArrDB)) = {''}; % fix
        A.clickDBtimeMs = cell2mat(A.corArrDB(:,1)); % ms, tider for DownBeat
        A.corValArrB = makeCorValArrB(A.corArrDB, P.workDir, P.noBeatsPerBar); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
        A.clickBtimeMs = A.corValArrB(:,1); % ms, tider for Beat
        A.cntArr525 = makeCntArr525(A.corValArrB);
 
        plotCurves(A, P);
    end    
    
%%

    % Klikk i WAV for å justere DB
    
    if GUI.y > -0.3 
        [GUI.dBno] = findNermesteDBbeggeRetninger(GUI.x, A.clickDBtimeMs);
        GUI.wavSampNr = GUI.x; % = findWavEdge(A.musArr525, GUI.x);
        GUI.msec = sa2ms(GUI.wavSampNr);
        A.corArrDB{GUI.dBno, 1} = GUI.msec;
        writecell(A.corArrDB, [P.workDir 'cor.xls']);
        
        % reload
        A.corArrDB = readcell([P.workDir 'cor.xls']); 
        A.corArrDB(cellfun(@(x) any(ismissing(x)), A.corArrDB)) = {''}; 
        A.clickDBtimeMs = cell2mat(A.corArrDB(:,1)); % ms, tider for DownBeat
        A.corValArrB = makeCorValArrB(A.corArrDB, P.workDir, P.noBeatsPerBar); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
        A.clickBtimeMs = A.corValArrB(:,1); % ms, tider for Beat
        A.cntArr525 = makeCntArr525(A.corValArrB);
        
        A.clickTrack44100 = makeClickTrack44100(A.clickDBtimeMs, A.musArr44100); % DB Klikk med lyd
        A.wavClick44100 = A.clickTrack44100 + A.musArr44100;
        
        plotCurves(A, P);
    end  

end



































